#!/bin/bash

. /usr/local/Reductor/etc/const

dev="${1:-eth1}"
count="${2:-1000}"

tcpdump -nneei $dev -c $count -w /tmp/mirror.pcap 2>/dev/null

echo "# Протоколы в зеркале (без разворачивания):"
tcpdump -qnnee -r /tmp/mirror.pcap 2>/dev/null | cut -d ' ' -f5 | sort -u | tr -d ','
echo
echo "# Тэги vlan:"
tcpdump -nee -r /tmp/mirror.pcap 2>/dev/null | egrep -o "vlan [0-9]+" | sort -u
echo
echo "# Версии IP-протокола"
tcpdump -nee -r /tmp/mirror.pcap 2>/dev/null | grep -o IPv[46] | sort -u
echo
echo "# Пакеты VPN:"
tcpdump -nee -r /tmp/mirror.pcap 2>/dev/null | egrep -o 'ethertype PP[^ ]+' | sort -u
echo
echo "# Пакетов с tcp src port 80 (всего $count)"
src_count="$(tcpdump -nn -r /tmp/mirror.pcap tcp src port 80 2>/dev/null | wc -l)"
echo $src_count
echo
echo "# Пакетов с tcp dst port 80 (всего $count)"
dst_count="$(tcpdump -nn -r /tmp/mirror.pcap tcp dst port 80 2>/dev/null | wc -l)"
echo $dst_count
echo
if [ "$src_count" -gt "$dst_count" ]; then
	echo 'WARNING: Пакетов с src port 80 больше, чем с dst port 80, скорее всего зеркало настроено задом наперёд'
	echo
fi
ip="$(ip r g 8.8.8.8 | egrep -o src.* | egrep -o $ip_regex)"
echo "# Наличие IP с которым уходим в default route в зеркале ($ip):"
if [ "$(tcpdump -nn -r /tmp/mirror.pcap host $ip 2>/dev/null | wc -l)" = 0 ]; then
	echo "Отсутствует"
else
	echo "Присутствует"
fi
